.\"	$NetBSD$
.\"
.\"	$OpenBSD: mem.4,v 1.1 2004/03/17 00:42:43 miod Exp $
.\"
.\" Copyright (c) 2004, Miodrag Vallat.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
.\" STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
.\" ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd March 16, 2004
.Dt MEM 4 hp700
.Os
.Sh NAME
.Nm mem ,
.Nm kmem
.Nd memory files and memory controller
.Sh SYNOPSIS
.Cd "mem* at mainbus0"
.Sh DESCRIPTION
The
.Nm
driver controls and restricts access to the systems memory
by the hardware buses and the processor.
.Pp
It also provides an interface to userland through the special files
.Pa /dev/mem
and
.Pa /dev/kmem .
Physical memory is accessed through
.Pa /dev/mem ,
while kernel virtual memory is accessed through
.Pa /dev/kmem .
Access to kernel virtual addresses not currently mapped to memory will fail.
On hp700, the physical memory range is always contiguous and starts at
address 0; kernel virtual memory begins at address 0 as well.
.Pp
The writeability of the
.Pa /dev/mem
and
.Pa /dev/kmem
special files are controlled by the system securelevel in addition to the
filesystem permissions.
.Sh FILES
.Bl -tag -width /dev/kmem -compact
.It Pa /dev/mem
.It Pa /dev/kmem
.El
.Sh HISTORY
The
.Nm
driver originates from
.Ox .
It was ported to
.Nx 1.6
by Matthew Fredette.
.Sh BUGS
On some systems featuring a
.Dq Viper
memory controller,
.Nx
may not configure bus arbitration correctly, causing the boot process
to freeze during either
.Nm
or
.Xr cpu 4
device probe.
